import re

bnc_sub_dict = \
      {'<blank>': ' ',
       'per cent': 'percent',
       'per<blank>cent': 'percent',
       'something': 'thing',
       'everything': 'thing',
       'anything': 'thing',
       'nothing': 'thing',
       'someone': 'person',
       'anyone': 'person',
       'no one': 'person'}
	   


def bnc_word_to_wn_word(bnc_word):
    for k in bnc_sub_dict:
       bnc_word = re.sub(k, bnc_sub_dict[k], bnc_word)
    return bnc_word


def bnc_pos_to_wn_pos (bnc_pos):
    """
    Yuk.
    """
    test = bnc_pos[0].lower()
    if test == 'v' or test == 'n':
        return test
    else:
        return None

