#!/usr/bin/env python
import sys, os.path,time
#from dependency_db import word_deprel_ct_dict, deprel_ct_dict, word_ct_dict, lemma_dict, lexeme_deprel_ct_dict, lexeme_ct_dict, nearest_neighbor_dict, rel_nearest_neighbor_dict, decodebook,inv_char,pruning_bound, get_deprel_info, print_deprel_profile, convert_to_mi, read_dependency_file, find_nearest_neighbors, find_nearest_neighbor, read_nn_file, make_neighborhood_graph, counts_to_mutual_info, counts_to_mutual_info_nonneg, counts_to_pointwise_mutual_info, counts_to_t_test, counts_to_t_test_nonneg, IRad, conditional_probs, lin, lin_no_neg, lin_no_neg2, lin_no_neg3, lin_no_neg_principled, dot_prod, dot_prod_no_neg, jaccard,counts_to_undiscounted_pointwise_mutual_info, counts_to_pointwise_mutual_info_nonneg, sqrt_freq, counts_to_info, dice_dagger, dice_dagger_no_neg, balaz_vec, read_dependency_file_helper,gr_counts_to_pointwise_mutual_info, make_mi_filename,compare_nn_dicts,make_nn_file_name
from dependency_db import convert_to_mi, find_nearest_neighbors, read_dependency_file_helper, compare_nn_dicts, make_nn_file_name,make_mi_filename, run_nearest_neighbor_experiment, results_dict
#import sim_measures

#default_sim_func_list = ['dot_prod', 'lin_no_neg','dice_dagger']
#default_sim_func_list = ['lin_no_neg','dice_dagger_all_neg']
default_sim_func_list = ['lin_no_neg','dot_prod']
alt_default_sim_func_list = ['dice_dot_prod_sq_rt', 'dice_dot_min_sq_rt']

new_wt_file_str = \
"""
Making a new Wt file %s  using dependency_train_file %s
Using suffix str %s ext str %s
"""
def run_dependency_db_experiment (weight_func_name='counts_to_pointwise_mutual_info', \
                                  nonneg_weight_func=False,\
                                  sim_func_name='none',  \
                                  norm = 'l2',\
                                  create_wt_file=False,\
                                  prune = False,\
                                  ext_wt_file_name=None,\
                                  prefix='',\
                                  compare_nn_file = None,\
                                  pos='NN',\
                                  write_dir = '',
                                  top_n=500, \
                                  verbose=False):
     global dependency_train_file, nearest_neighbor_file
     # weight_func = getattr(sim_measures,weight_func_name)
     # sim_func =  getattr(sim_measures,sim_func_name)
     print 'weight fn: %s ' % (weight_func_name, )
     print 'weight fn restricted to positive values: %s' % (nonneg_weight_func,)
     print 'norm value: %s' % (norm_to_string[norm],)
     # This has been one huge pain!
     #if sim_func_name in wt_suffix_dict.values():
     #     wt_suffix = '_' + wt_suffix_dict[norm]
     #else:
     #    wt_suffix = ''
     wt_suffix = ''
     # if sim_func_name == 'dot_prod' and weight_func_name == 'counts_to_pointwise_mutual_info_nonneg'\
     #       and norm == '':
     #     ## Non_norm and dot_prod redundant.  Exception.
     #     wt_ext = '_pmi_nonneg'
     # else:
     #     wt_ext = '_' + ext_dict[weight_func_name,norm]
     wt_ext = '_' + ext_dict[weight_func_name,norm]
     print 'Wt suffix: %s Wt ext: %s' % (wt_suffix,wt_ext)
     #pruning_affix = pruning_dict[prune]
     #pruned_base = base + pruning_affix
     #new_wt_file_name = pruned_base + wt_suffix + '_' + wt_ext + df_ext
     new_wt_file_name = make_mi_filename(dependency_train_file, prefix, prune, wt_suffix, wt_ext)
     if create_wt_file:
          print new_wt_file_str %   (new_wt_file_name, dependency_train_file, wt_suffix, wt_ext)
          convert_to_mi(dependency_train_file,\
                        mi_func = weight_func_name, normalize=norm,\
                        suffix=wt_suffix,ext= wt_ext, prune=prune,\
                        new_wt_file=new_wt_file_name, write_dir=write_dir)
     else:
          if ext_wt_file_name:
               new_wt_file_name= ext_wt_file_name
          try:
               print 'Attempting to read Wt file %s' % (new_wt_file_name,)
               read_dependency_file_helper (new_wt_file_name,False,False)
          except IOError, e:
               print e
               print new_wt_file_str %   (new_wt_file_name, dependency_train_file, wt_suffix, wt_ext)
               convert_to_mi(dependency_train_file,\
                             mi_func = weight_func_name, normalize=norm,\
                             suffix=wt_suffix,ext= wt_ext, prune=prune,\
                             new_wt_file=new_wt_file_name, write_dir=write_dir)

     print
     # raise Exception, 'Inserted exception for debugging. Ending early!'
     print 'NN suffix: _%s NN ext %s' % (sim_func_name, wt_ext)
     print 'Top_n %s' % (top_n,)
     # the string 'rel_pp_nearest_neighbor_' is the default stem for an nn dict file name.
     # can be varied with 'prefix' keyword argument.
     # Pass in other experiment-specific components of name.
     #nn_file_name = \
     #  make_nn_file_name(pos, sim_func_name, wt_ext[1:])
     # print 'Nearest_neighbor filename: %s' % (nn_file_name,)
     # JMG deleted keyword arg  suffix = '_' + nn_suffix_dict[sim_func_name,norm],
     if sim_func_name == 'none':
          sim_func_list = default_sim_func_list
          print 'Using default sim functions: %s' % default_sim_func_list
     else:
          sim_func_list = [sim_func_name]
          print 'sim func: %s' % (sim_func_name,)
     run_nearest_neighbor_experiment(dependency_train_file, nearest_neighbor_file, \
                                     wt_ext[1:], sim_func_list = sim_func_list, \
                                     pos = pos, verbose=verbose, top_n=top_n,\
                                     wt_func=weight_func_name)
     #find_nearest_neighbors (dependency_train_file, nearest_neighbor_file=nearest_neighbor_file, \
     #                        top_n=500, preserve_pos=True, sim_func=sim_func_name, \
     #                        pos=pos,
     #                        ext=wt_ext,
     #                        wt_file = new_wt_file_name)
     if compare_nn_file:
          compare_nn_dicts(compare_nn_file)
          
# Added gr_counts_to_pointwise_mutual_info
ext_dict = \
{('counts_to_pointwise_mutual_info','l2'): 'pmi',
 ('counts_to_pointwise_mutual_info',''): 'pmi_no_norm',
 ('counts_to_shifted_pointwise_mutual_info','l2'): 'spmi',
 ('counts_to_shifted_pointwise_mutual_info',''): 'spmi_no_norm',
 ('gr_counts_to_pointwise_mutual_info','l2'): 'pmi',
 ('gr_counts_to_pointwise_mutual_info',''): 'pmi_no_norm',
 ('counts_to_mutual_info', 'l2'): 'mi',
 ('counts_to_mutual_info', ''): 'mi',
 ('counts_to_mutual_info_nonneg', 'l2'): 'mi_nonneg',
 ('counts_to_mutual_info_nonneg', ''): 'mi_nonneg_no_norm',
 ('counts_to_pointwise_mutual_info_nonneg','l2'): 'pmi_nonneg',
 ('counts_to_pointwise_mutual_info_nonneg',''): 'pmi_nonneg_no_norm',
 ('counts_to_pointwise_mutual_info_sqrt','l2'): 'pmi_sqrt',
 ('counts_to_pointwise_mutual_info_sqrt',''): 'pmi_sqrt_no_norm',
 ('counts_to_undiscounted_pointwise_mutual_info','l2'): 'pmi_no_disc',
 ('counts_to_undiscounted_pointwise_mutual_info',''): 'pmi_no_disc_no_norm',
 ('counts_to_t_test', 'l2'): 't_test',
 ('counts_to_t_test', ''): 't_test_no_norm',
 ('counts_to_z_score', 'l2'): 'z_score',
 ('counts_to_z_score', ''): 'z_score_no_norm',
 ('counts_to_dice', 'l2'): 'dice_wt',
 ('counts_to_dice', ''): 'dice_wt_no_norm',
 ('counts_to_log_dice', 'l2'): 'log_dice_wt',
 ('counts_to_log_dice', ''): 'log_dice_wt_no_norm',
 ('counts_to_scp', 'l2'): 'scp',
 ('counts_to_scp', ''): 'scp_no_norm',
 ('counts_to_log_scp', 'l2'): 'log_scp',
 ('counts_to_log_scp', ''): 'log_scp_no_norm',
 ('counts_to_t_test_discounted', 'l2'): 't_test_discounted',
 ('counts_to_t_test_discounted', ''): 't_test_discounted_no_norm',
 ('counts_to_t_test_shifted', 'l2'): 's_t_test',
 ('counts_to_t_test_shifted', ''): 's_t_test_no_norm',
 ('counts_to_t_test_shifted_discounted', 'l2'): 's_t_test_discounted',
 ('counts_to_t_test_shifted_discounted', ''): 's_t_test_discounted_no_norm',
 ('counts_to_t_test_scale_shifted', 'l2'): 's_s_t_test',
 ('counts_to_t_test_scale_shifted', ''): 's_s_t_test_no_norm',
 ('counts_to_t_test_nonneg','l2'): 't_test_nonneg',
 ('counts_to_t_test_nonneg',''): 't_test_nonneg_no_norm',
 ('conditional_probs','l1'): 'prob',
 # Hellinger distance
 ('sqrt_freq','l1'): 'prob_sqrt',
 }

"""
nn_suffix_dict = \
{('dot_prod',''): 'dot_prod',
  ('dot_prod','l2'): 'dot_prod',
  # Weird variant of dot  prod sim func.  Not tested.
  ('dot_prod_no_neg',''): 'dot_prod_no_neg',
  ('dot_prod_no_neg','l2'): 'dot_prod_no_neg',
  ('IRad','l1'): 'irad',
  ('lin','l2'): 'lin',
  ('lin',''): 'lin',
  ('lin_no_neg','l2'): 'lin_no_neg',
  ('lin_no_neg',''): 'lin_no_neg',
  ('lin_no_neg_principled','l2'): 'lin_no_neg_principled',
  ('lin_no_neg_principled',''): 'lin_no_neg_principled',
  ('lin_no_neg2','l2'): 'lin_no_neg2',
  ('lin_no_neg2',''): 'lin_no_neg2',
  ('lin_no_neg3','l2'): 'lin_no_neg3',
  ('lin_no_neg3',''): 'lin_no_neg3',
  ('dice_dagger','l2'): 'dice_dagger',
  ('dice_dagger',''): 'dice_dagger',
  ('dice_dagger_no_neg','l2'): 'dice_dagger',
  ('dice_dagger_no_neg',''): 'dice_dagger',
  # Use this with wt function of unrestricted range.
  ('dice_dagger_naive','l2'): 'dice_dagger_naive',
  ('dice_dagger_naive',''): 'dice_dagger_naive',
      }
"""

norm_to_string = \
{'l2':'l2',
 'l1': 'l1',
 '' : 'no_norm'
 }

def main():

    import optparse

    option_list = [
         optparse.make_option('-w', '--weight_func_name', default='counts_to_pointwise_mutual_info',\
                              metavar='WEIGHT_FUNC', help='Function to weight counts in word vectors'),
         optparse.make_option('-s', '--sim_func_name', default='none',\
                              metavar='SIM_FUNC', help='Function to evaluate similarity of two word vectors'),
         optparse.make_option('-r', '--nonneg_weight_func', action='store_true', default=False,\
                              help='True if the weight function is restricted to nonnegative vals'),
         optparse.make_option('-x', '--pos', default='NN',\
                              help='Part of speech for nearest neighbor experiments'),
         optparse.make_option('-c', '--create_wt_file', action='store_true', default=False,\
                              help='True means create a new deprel weight file'),
         optparse.make_option('-p', '--prune', action='store_true', default=False,\
                              help='True means prune low count lex items'),
         optparse.make_option('-n', '--norm', default='l2',  help="One of l2, l1, or none"),
         optparse.make_option('-f', '--ext_wt_file_name', default='',\
                              metavar='FILE', help='path to deprel weights training file'),
         optparse.make_option('-t', '--top_rank', \
                              default = '0', \
                              help= 'integer rank of top ranking lexitem to find nearest neighbor of: 0 for the most frequent lex item', \
                              metavar='RANK'),
         optparse.make_option('-b', '--bottom_rank', \
                              help= 'integer rank of bottom ranking lexitem to find nearest neighbor of: 500 for the 501st most frequent lex item', metavar='RANK', default='500')
         ]
    p = optparse.OptionParser(option_list=option_list)
    options, arguments = p.parse_args()
    assert not (options.ext_wt_file_name and options.create_wt_file), 'Cant use both -c and -f options.'
    if options.norm == 'none':
         norm = ''
    else:
         norm = options.norm
    try:
         top = int(options.top_rank)
         bottom = int(options.bottom_rank)
         if top == 0:
              top_n = bottom
         elif top < 0 or bottom < 0:
              # People sometimes type -b -1000.  Ugh.
              print 'Usage: -t and -b options do not accept negative integer values!'
              sys.exit()
         else:
              top_n = (top,bottom)
    except ValueError:
         print 'Usage: -t and -b options take positive integer values!'
         print options.help
         sys.exit()
    if options.create_wt_file  == 'False' or options.create_wt_file  == 'True':
         print 'Bogus create_wt file string val: %s' % options.create_wt_file
    elif options.create_wt_file  == False or options.create_wt_file  == True:
         print 'Valid create_wt file Boolean val: %s' % options.create_wt_file
    else:
         print 'Mysterious create_wt_file value %s' % options.create_wt_file
    run_dependency_db_experiment (weight_func_name = options.weight_func_name,\
                                  nonneg_weight_func = options.nonneg_weight_func,\
                                  sim_func_name = options.sim_func_name,  \
                                  norm = norm,\
                                  create_wt_file=options.create_wt_file,\
                                  pos = options.pos,
                                  top_n=top_n
                                  )

    

if __name__ == '__main__':
    import os.path,sys

    #home = os.environ['HOME']
    #root_dir = os.path.join(home,'Desktop')
    #dependency_db_dir = os.path.join(root_dir, 'SWIDSAS','dependency_DB')
    dependency_db_dir = os.environ['DEPEND_DB']
    os.chdir(dependency_db_dir)

    ## Global variables containing names of files assumed to exist
    dependency_keys_file = '../dep_data/dependency_DB.keys'
    #dependency_train_file = '../dep_data/dependency_DB_pruned.train'
    dependency_train_file = '../dep_data/dependency_DB.train'
    # file created while executing C{main}, this global used for name patterns.  Needed.
    #nearest_neighbor_file = 'pruned_nearest_neighbor.dict'
    nearest_neighbor_file = 'nearest_neighbor.dict'

    main()

